/* ini2bin.c *************************************\
*                                                 *
*   Converter of *.ini-files to (float) binaries  *
*     (designed for use with "mpi_duct.ini")      *
*                                                 * 
\*************************************************/

#include <stdio.h>
#include <stdlib.h>

/*********
*  MAIN  *
*********/
int main(void)   /* int argc, char *argv[1] */
{
unsigned LEN, HIG, DEP;
float deltaX, deltaY, deltaZ, deltaT;
unsigned Answer, numstep;
float mu_L, Pr_L, Pr_T, Cs, g, tau_w, R0;
unsigned f_step;

FILE *pFin, *pFout;
char str[80];
unsigned i;
float buf;

   // Open file "mpi_duct.ini"
   if ((pFin = (FILE *)fopen("mpi_duct.ini", "r")) == NULL) {
      fprintf(stderr, "Cannot open \"mpi_duct.ini\" file\n");
      exit(-1);
   }
   // Open file "mpi_duct.ini" in binary mode
   if ((pFout = (FILE *)fopen("mpi_duct.bin", "wb")) == NULL) {
      fprintf(stderr, "Cannot open \"mpi_duct.bin\" file\n");
      exit(-1);
   }
   i = 0;
   do{
      if (fgets(str, 80, pFin) != NULL) {
         switch (i) {
            case  0: printf("LEN    = %d\n", LEN    = atoi(str ) ); break;
            case  1: printf("HIG    = %d\n", HIG    = atoi(str ) ); break;
            case  2: printf("DEP    = %d\n", DEP    = atoi(str ) ); break;
            case  3: printf("deltaX = %f\n", deltaX = atof(str ) ); break;
            case  4: printf("deltaY = %f\n", deltaY = atof(str ) ); break;
            case  5: printf("deltaZ = %f\n", deltaZ = atof(str ) ); break;
            case  6: printf("deltaT = %f\n", deltaT = atof(str ) ); break;
            case  7: printf("Answer = %d\n", Answer = atoi(str ) ); break;
            case  8: printf("numstep= %d\n", numstep= atoi(str ) ); break;
            case  9: printf("mu_L   = %f\n", mu_L   = atof(str ) ); break;
            case 10: printf("Pr_L   = %f\n", Pr_L   = atof(str ) ); break;
            case 11: printf("Pr_T   = %f\n", Pr_T   = atof(str ) ); break;
            case 12: printf("Cs     = %f\n", Cs     = atof(str ) ); break;
            case 13: printf("g      = %f\n", g      = atof(str ) ); break;
            case 14: printf("tau_w  = %f\n", tau_w  = atof(str ) ); break;
            case 15: printf("R0     = %f\n", R0     = atof(str ) ); break;
            case 16: printf("f_step = %d\n",f_step  = atoi(str ) ); break;
            default: 
		fprintf(stderr, "Error reading \"mpi_duct.ini\" file\n");
		exit(-1);
         } // end switch
         //
         buf = atof(str);
         fwrite(&buf, sizeof(float), 1, pFout);
         // 
	 i++;
      } // end if()
      else {
         fprintf(stderr, "Error while reading \"mpi_duct.ini\" file\n");
         exit(-1);
      }
   } while (i < 17);

   fclose(pFout);
   fclose(pFin);
   return 0;
} 

//--- end ini2bin.c ---

/*
   if( argc < 2 ) {
      puts( "Usage: /.filter.out file_name1" );
      return 0;
   }      
*/

