#include <stdio.h>
#include <math.h>

//#define k 1.40000 
#define k 1.20000    // dx/dy = dx/dz: cell size aspect ratio

int main(void)
{
float
  H = 1., R = 1.0, P = 100000., K = 1.4,
  Re, M, mu, g, tau, lambda, lambda_o, u, a,

  numproc, numstep, Nx, Ny,
  dx, dy, kpd,
  ppp = 17220., // on 1 Alfa-21164 with 60% effect. on 13 proc
  Time;


  printf("Re = "); scanf("%f", &Re);
  printf("M = ");  scanf("%f", &M);

  a = sqrt(K * P / R);

  u = M * a;

  lambda = 0.03;
  do {
    lambda_o = lambda;
    lambda = Re * sqrt(lambda);
    lambda = 2 * log10(lambda) - 0.8;
    lambda *= lambda;
    lambda = 1. / lambda;
  } while (fabs(lambda - lambda_o) > 1.e-15);

  tau = (lambda / 8.) * R * u * u;
  g = 4 * tau / (R * H);
  mu = R * u * H / Re;

  printf("lambda = %f\n", lambda);
  printf("u = %f\n", u);
  printf("mu = %.7f\n", mu);
  printf("tau = %f\n", tau);
  printf("g = %f\n", g);

  printf("Nz = Ny = "); scanf("%f", &Ny);
  printf("on 1 processor Nx = "); scanf("%f", &Nx);
  printf("numstep = "); scanf("%f", &numstep);
  printf("numproc = "); scanf("%f", &numproc);

  dy = H / Ny;
  printf("dy = dz = %f\n", dy);
  dx = k * dy;

  printf("dx = %f,  dx/dy = %.4f \n", dx, dx/dy);
  printf("L = %f\n", dx * numproc * Nx);
  Time = numstep * Ny * Ny * Nx / ppp;
  printf("Time = %.0f secs = %f hours = %f days\n", Time, 
	 Time / 3600., Time / (3600. * 24.));

  return 0;
} // end main()

//--- end prep.c ---